/****************************************
*             CONSTRUCTEURS             *
****************************************/
template<class T,int n> Rn<T,n>::Rn()
{
}
template<class T,int n> Rn<T,n>::Rn(T Body[n])
{
  int i;
  for (i=0;i<n;i++)
    body[i]=Body[i];
}
template<class T,int n> Rn<T,n>::~Rn()
{

}

/****************************************
*              OPERATEURS               *
****************************************/
template<class T,int n> Rn<T,n> Rn<T,n>::operator+(const Rn<T,n> &autre) const
{
  T temp[n];
  int i;
  for (i=0;i<n;i++)
    temp[i]=body[i]+autre.body[i];
  return Rn<T,n>(temp);
}
template<class T,int n> Rn<T,n> Rn<T,n>::operator*(const T &autre) const
{
  T temp[n];
  int i;
  for (i=0;i<n;i++)
    temp[i]=autre*body[i];
  return Rn<T,n>(temp);
}
template<class T,int n> Rn<T,n> Rn<T,n>::operator*(const Rn<T,n> &autre) const
{
  T temp[n];
  int i;
  for (i=0;i<n;i++)
    temp[i]=body[i]*autre.body[i];
  return Rn<T,n>(temp);
}
template<class T,int n> Rn<T,n> Rn<T,n>::operator-(const Rn<T,n> &autre) const
{
  T temp[n];
  int i;
  for (i=0;i<n;i++)
    temp[i]=body[i]-autre.body[i];
  return Rn<T,n>(temp);
}
template<class T,int n> Rn<T,n> Rn<T,n>::operator/(const Rn<T,n> &autre) const
{
  T temp[n];
  int i;
  for (i=0;i<n;i++)
    temp[i]=body[i]/autre.body[i];
  return Rn<T,n>(temp);
}

template<class T,int n> TextXP::advio& operator<<(TextXP::advio& s,const Rn<T,n> &moi)
{
  int i;
  for (i=0;i<n;i++)
  {
    s << moi.body[i];
    if (i+1<n) s << " ";
  }
  return s;
}

template<class T,int n> TextXP::advio& operator>>(TextXP::advio& s,Rn<T,n> &moi)
{
  int i;
  for (i=0;i<n;i++)
    s >> moi.body[i];
  return s;
}
