template<class T> STACK<T>::STACK()
{
  next=NULL;
  object=NULL;
}

template<class T> STACK<T>::~STACK()
{
  if (object!=NULL)
    delete object;
  if (next!=NULL)
    delete next;
}

template<class T> void STACK<T>::push(T n)
{
  STACK<T> *Objet=new STACK<T>;
  Objet->next=next;
  Objet->object=new T;
  *Objet->object=n;
  next=Objet;
}

template<class T> T STACK<T>::pop()
{
  T t;
  if (IsEmpty())
    return T();
  STACK<T> *tmp=next->next;
  next->next=NULL;    //trs important pour viter la propagation de l'vnement de destruction.
  t=*next->object;
  delete next->object;
  next->object=NULL;
  delete next;
  next=tmp;
  return t;
}

template<class T> T STACK<T>::top()
{
  T t;
  if (IsEmpty())
    return T();
  t=*next->object;
  return t;
}

template<class T> bool STACK<T>::IsEmpty()
{
  if (next==NULL)
    return true;
  else 
    return false;
}

template<class T> STACK<T>& STACK<T>::operator<<(T t)
{
  push(t);
  return *this;
}

template<class T> STACK<T>& STACK<T>::operator>>(T& t)
{
  t=pop();
  return *this;
}