/****************************************
*             CONSTRUCTEURS             *
****************************************/
template<class T> C<T>::C()
{
  re=0;
  im=0;
}
template<class T> C<T>::C(T Re,T Im)
{
  re=Re;
  im=Im;
}
template<class T> C<T>::~C()
{
}

/****************************************
*              OPERATEURS               *
****************************************/
template<class T> C<T> C<T>::operator+(const C<T> &autre) const
{
  return C(re+autre.re,im+autre.im);
}
template<class T> C<T> C<T>::operator*(const C<T> &autre) const
{
  return C(re*autre.re-im*autre.im,re*autre.im+im*autre.re);
}
template<class T> C<T> C<T>::operator-(const C<T> &autre) const
{
  return C(re-autre.re,im-autre.im);
}
template<class T> C<T> C<T>::operator/(const C<T> &autre) const
{
  double d=autre.re*autre.re+autre.im*autre.im;
  return C((re*autre.re+im*autre.im)/d,(im*autre.re-re*autre.im)/d);
}

template<class T> TextXP::advio& operator<<(TextXP::advio& s,const C<T> &moi)
{
  s << "(" << moi.re << ";" << moi.im << ")";
  return s;
}

template<class T> TextXP::advio& operator>>(TextXP::advio& s,C<T> &moi)
{
  s >> moi.re >> moi.im;
  return s;
}
