class R
{
  public:
    R();
    R(double v);
    ~R();
    R operator+(const R &autre) const;
    R operator*(const R &autre) const;
    R operator-(const R &autre) const;
    R operator/(const R &autre) const;
    friend TextXP::advio& operator<<(TextXP::advio& s,const R &moi);
    friend TextXP::advio& operator>>(TextXP::advio& s,R &moi);
    double val;
};

class N
{
  public:
    N();
    N(int v);
    ~N();
    N operator+(const N &autre) const;
    N operator*(const N &autre) const;
    N operator-(const N &autre) const;
    N operator/(const N &autre) const;
    friend TextXP::advio& operator<<(TextXP::advio& s,const N &moi);
    friend TextXP::advio& operator>>(TextXP::advio& s,N &moi);
    int val;
};

template<class T> class C
{
  public:
    C();
    C(T Ce,T Im);
    ~C();
    C operator+(const C &autre) const;
    C operator*(const C &autre) const;
    C operator-(const C &autre) const;
    C operator/(const C &autre) const;
    friend TextXP::advio& operator<<(TextXP::advio& s,const C &moi);
    friend TextXP::advio& operator>>(TextXP::advio& s,C &moi);
    T re,im;
};

template<class T,int n> class Rn
{
  public:
    Rn();
    Rn(T Body[n]);
    ~Rn();
    Rn<T,n> operator+(const Rn<T,n> &autre) const;
    Rn<T,n> operator*(const T &autre) const;
    Rn<T,n> operator*(const Rn<T,n> &autre) const;
    Rn<T,n> operator-(const Rn<T,n> &autre) const;
    Rn<T,n> operator/(const Rn<T,n> &autre) const;
    friend TextXP::advio& operator<<(TextXP::advio& s,const Rn<T,n> &moi);
    friend TextXP::advio& operator>>(TextXP::advio& s,Rn<T,n> &moi);
    T body[n];
};

template<class T,int n> class Matrice
{
  public:
    Matrice();
    Matrice(T Body[n][n]);
    ~Matrice();
    Matrice<T,n> operator+(const Matrice<T,n> &autre) const;
    Matrice<T,n> operator*(const Matrice<T,n> &autre) const;    //Ce n'est pas un produit matriciel.
    Matrice<T,n> operator-(const Matrice<T,n> &autre) const;
    Matrice<T,n> operator/(const Matrice<T,n> &autre) const;
    friend TextXP::advio& operator<<(TextXP::advio& s,const Matrice<T,n> &moi);
    friend TextXP::advio& operator>>(TextXP::advio& s,Matrice<T,n> &moi);
    T body[n][n];
};

#include "LA_C.h"
#include "LA_Rn.h"
